Index: src/Makefile.am
===================================================================
--- src/Makefile.am	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -2,13 +2,9 @@
 # Also indentation by a single tab
 
-SUBDIRS = Actions Exceptions Parser UIElements
-
-# this includes source files that need to be present at multiple points
-HELPERSOURCE =  \
-  Helpers/Assert.cpp \
-  Helpers/MemDebug.cpp
-		        
+SUBDIRS = Actions Exceptions Helpers LinearAlgebra Parser UIElements
+
 ATOMSOURCE = \
   atom.cpp \
+  AtomicInfo.cpp \
   atom_atominfo.cpp \
   atom_bondedparticle.cpp \
@@ -21,4 +17,5 @@
 ATOMHEADER = \
   atom.hpp \
+  AtomicInfo.hpp \
   atom_atominfo.hpp \
   atom_bondedparticle.hpp \
@@ -30,19 +27,4 @@
   atom_trajectoryparticleinfo.hpp
 
-LINALGSOURCE = \
-  ${HELPERSOURCE} \
-  gslmatrix.cpp \
-  gslvector.cpp \
-  linearsystemofequations.cpp \
-  Space.cpp \
-  vector.cpp
-			   
-LINALGHEADER = \
-  gslmatrix.hpp \
-  gslvector.hpp \
-  linearsystemofequations.hpp \
-  Space.hpp \
-  vector.hpp
-			   
 ANALYSISSOURCE = \
   analysis_bonds.cpp \
@@ -76,4 +58,5 @@
   Actions/MethodAction.hpp \
   Actions/Process.hpp
+
 
 PATTERNSOURCE = \
@@ -92,25 +75,10 @@
   Shapes/Shape.hpp \
   Shapes/ShapeOps.hpp
+
   
-
-QTUIMOC_HEADER = UIElements/QT4/QTDialog.hpp \
-	UIElements/QT4/QTMainWindow.hpp \
-	UIElements/Menu/QT4/QTMenu.hpp \
-	UIElements/Views/QT4/QTWorldView.hpp \
-	UIElements/Views/QT4/GLMoleculeView.hpp \
-	UIElements/Views/QT4/QTMoleculeView.hpp \
-	UIElements/Views/QT4/QTStatusBar.hpp
- 
-QTUIMOC_TARGETS = QTMainWindow.moc.cpp \
-	QTMenu.moc.cpp\
-	QTDialog.moc.cpp \
-	QTWorldView.moc.cpp \
-	GLMoleculeView.moc.cpp \
-	QTMoleculeView.moc.cpp \
-	QTStatusBar.moc.cpp
-
 DESCRIPTORSOURCE = Descriptors/AtomDescriptor.cpp \
   Descriptors/AtomIdDescriptor.cpp \
   Descriptors/AtomSelectionDescriptor.cpp \
+  Descriptors/AtomShapeDescriptor.cpp \
   Descriptors/AtomTypeDescriptor.cpp \
   Descriptors/MoleculeDescriptor.cpp \
@@ -125,4 +93,5 @@
   Descriptors/AtomIdDescriptor.hpp \
   Descriptors/AtomSelectionDescriptor.hpp \
+  Descriptors/AtomShapeDescriptor.hpp \
   Descriptors/AtomTypeDescriptor.hpp \
   Descriptors/MoleculeDescriptor.hpp \
@@ -132,6 +101,32 @@
   Descriptors/MoleculePtrDescriptor.hpp \
   Descriptors/MoleculeSelectionDescriptor.cpp
+  
+THERMOSTATSOURCE = \
+  Thermostats/Berendsen.cpp \
+  Thermostats/GaussianThermostat.cpp \
+  Thermostats/Langevin.cpp \
+  Thermostats/NoseHoover.cpp \
+  Thermostats/NoThermostat.cpp \
+  Thermostats/Thermostat.cpp \
+  Thermostats/Woodcock.cpp
+
+THERMOSTATHEADER = \
+  Thermostats/Berendsen.hpp \
+  Thermostats/GaussianThermostat.hpp \
+  Thermostats/Langevin.hpp \
+  Thermostats/NoseHoover.hpp \
+  Thermostats/NoThermostat.hpp \
+  Thermostats/Thermostat.hpp \
+  Thermostats/Woodcock.hpp
+
+QTUIMOC_HEADER = UIElements/QT4/QTDialog.hpp \
+	UIElements/QT4/QTMainWindow.hpp \
+	UIElements/Menu/QT4/QTMenu.hpp \
+	UIElements/Views/QT4/QTWorldView.hpp \
+	UIElements/Views/QT4/GLMoleculeView.hpp \
+	UIElements/Views/QT4/QTMoleculeView.hpp \
+	UIElements/Views/QT4/QTStatusBar.hpp
 				  
-QTUISOURCE = ${QTUIMOC_TARGETS} \
+QTUISOURCE = allmocs.moc.cpp \
 	UIElements/QT4/QTMainWindow.cpp \
 	UIElements/QT4/QTDialog.cpp \
@@ -147,13 +142,35 @@
 QTUI_DEFS =
 
-SOURCE = \
+TESSELATIONSOURCE = \
+  BoundaryLineSet.cpp \
+  BoundaryPointSet.cpp \
+  BoundaryPolygonSet.cpp \
+  BoundaryTriangleSet.cpp \
+  CandidateForTesselation.cpp \
+  PointCloud.cpp \
+  tesselation.cpp \
+  tesselationhelpers.cpp \
+  TesselPoint.cpp
+  
+TESSELATIONHEADER = \
+  BoundaryLineSet.hpp \
+  BoundaryPointSet.hpp \
+  BoundaryPolygonSet.hpp \
+  BoundaryTriangleSet.hpp \
+  CandidateForTesselation.hpp \
+  PointCloud.hpp \
+  tesselation.hpp \
+  tesselationhelpers.hpp \
+  TesselPoint.hpp
+
+MOLECUILDERSOURCE = \
   ${ANALYSISSOURCE} \
   ${ACTIONSSOURCE} \
   ${ATOMSOURCE} \
   ${PATTERNSOURCE} \
-  ${PARSERSOURCE} \
   ${SHAPESOURCE} \
   ${DESCRIPTORSOURCE} \
-  ${HELPERSOURCE} \
+  ${THERMOSTATSOURCE} \
+  ${TESSELATIONSOURCE} \
   bond.cpp \
   bondgraph.cpp \
@@ -163,18 +180,12 @@
   config.cpp \
   ConfigFileBuffer.cpp \
+  defs.cpp \
   element.cpp \
   elements_db.cpp \
   ellipsoid.cpp \
-  errorlogger.cpp \
   Formula.cpp \
   graph.cpp \
-  helpers.cpp \
-  info.cpp \
   leastsquaremin.cpp \
-  Line.cpp \
   linkedcell.cpp \
-  log.cpp \
-  logger.cpp \
-  Matrix.cpp \
   moleculelist.cpp \
   molecule.cpp \
@@ -186,24 +197,18 @@
   parser.cpp \
   periodentafel.cpp \
-  Plane.cpp \
-  Space.cpp \
-  tesselation.cpp \
-  tesselationhelpers.cpp \
   ThermoStatContainer.cpp \
   triangleintersectionlist.cpp \
   UIElements/UIFactory.cpp \
-  vector.cpp \
-  vector_ops.cpp \
-  verbose.cpp \
   World.cpp
 
-HEADER = \
+MOLECUILDERHEADER = \
   ${ANALYSISHEADER} \
   ${ACTIONSHEADER} \
   ${ATOMHEADER} \
-  ${PARSERHEADER} \
   ${PATTERNHEADER} \
   ${SHAPEHEADER} \
   ${DESCRIPTORHEADER} \
+  ${THERMOSTATHEADER} \
+  ${TESSELATIONHEADER} \
   bond.hpp \
   bondgraph.hpp \
@@ -217,36 +222,70 @@
   elements_db.hpp \
   ellipsoid.hpp \
-  errorlogger.hpp \
   Formula.hpp \
   graph.hpp \
-  helpers.hpp \
-  info.hpp \
   leastsquaremin.hpp \
-  Line.hpp \
   linkedcell.hpp \
   lists.hpp \
-  log.hpp \
-  logger.hpp \
-  Matrix.hpp \
   molecule.hpp \
-  molecule_template.hpp \
   parser.hpp \
   periodentafel.hpp \
-  Plane.hpp \
   stackclass.hpp \
-  tesselation.hpp \
-  tesselationhelpers.hpp \
   ThermoStatContainer.hpp \
   triangleintersectionlist.hpp \
   UIElements/UIFactory.hpp \
-  verbose.hpp \
-  vector_ops.hpp \
   World.hpp 
 
-# the following files are no longer used:
-#  memoryallocator.hpp \
-#  memoryallocator.cpp \
-#  memoryusageobserver.hpp \
-#  memoryusageobserver.cpp
+lib_LTLIBRARIES = libMolecuilder-@MOLECUILDER_API_VERSION@.la
+libMolecuilder_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+libMolecuilder_LIBS = \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+
+#	UIElements/libMolecuilderUI.a \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB}
+
+nobase_libMolecuilder_include_HEADERS = ${MOLECUILDERHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilder_@MOLECUILDER_API_VERSION@_la_SOURCES = ${MOLECUILDERSOURCE} $(srcdir)/version.c
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilder_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilder_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilder_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
 
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
@@ -254,13 +293,11 @@
 INCLUDES = -I$(top_srcdir)/src/unittests -I$(top_srcdir)/src/Actions -I$(top_srcdir)/src/UIElements
 
-noinst_LIBRARIES = libmolecuilder.a libgslwrapper.a libmenu.a
+noinst_LIBRARIES = libmenu.a
 bin_PROGRAMS = molecuilder molecuildergui joiner analyzer
+EXTRA_PROGRAMS = unity
 
 molecuilderdir = ${bindir}
 
-libmolecuilder_a_SOURCES = ${SOURCE} ${HEADER} $(srcdir)/version.c
-
 libmenu_a_SOURCES = ${UISOURCE} ${UIHEADER} 
-libgslwrapper_a_SOURCES = ${LINALGSOURCE} ${LINALGHEADER}
 
 molecuilder_DATA = elements.db valence.db orbitals.db Hbonddistance.db Hbondangle.db
@@ -270,18 +307,63 @@
 molecuilder_LDFLAGS = $(BOOST_LIB)
 molecuilder_SOURCES = builder.cpp
-molecuilder_LDADD = UIElements/libMolecuilderUI.a Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la libmolecuilder.a Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la libgslwrapper.a Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
+molecuilder_LDADD = \
+	UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+
 
 #Stuff for building the GUI using QT
 molecuildergui_SOURCES = ${QTUISOURCE} builder.cpp
-molecuildergui_SOURCES += $(srcdir)/version.c
 molecuildergui_CXXFLAGS = ${QT_CXXFLAGS} ${GLU_CXXFLAGS} -DUSE_GUI_QT
 molecuildergui_LDFLAGS = $(BOOST_LIB) ${QT_LDFLAGS} ${GLU_LDFLAGS}
-molecuildergui_LDADD = UIElements/libMolecuilderUI.a Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la libmolecuilder.a Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la libgslwrapper.a Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}  ${GUI_LIBS}
-
-joiner_SOURCES = joiner.cpp datacreator.cpp parser.cpp datacreator.hpp helpers.hpp parser.hpp periodentafel.hpp
-joiner_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
-
-analyzer_SOURCES = analyzer.cpp datacreator.cpp parser.cpp helpers.hpp periodentafel.hpp parser.hpp datacreator.hpp 
-analyzer_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
+
+unity_SOURCES = unity.cpp
+unity_LDADD = $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
+
+molecuildergui_LDADD = \
+	UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB} \
+	${GUI_LIBS}
+
+joiner_SOURCES = joiner.cpp datacreator.cpp datacreator.hpp periodentafel.hpp
+joiner_LDADD = \
+	UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+
+analyzer_SOURCES = analyzer.cpp datacreator.cpp periodentafel.hpp datacreator.hpp 
+analyzer_LDADD = \
+	UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la \
+	Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la \
+	LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
 
 #Rules needed for QT4
@@ -289,5 +371,6 @@
 # Therfore `%'-rules do not seem to work
 #Quick fix to get it done otherwise
-${QTUIMOC_TARGETS}: ${QTUIMOC_HEADER}
+allmocs.moc.cpp: ${QTUIMOC_HEADER}
+	echo "" > allmocs.moc.cpp;\
 	list='$(QTUIMOC_HEADER)'; for header in $$list; do \
 	echo "Making mocfile for $$header"; \
@@ -295,8 +378,7 @@
 	$(MOC) $(srcdir)/$$header -o $$target \
 	|| eval $$failcom; \
+	echo "#include \"$$target\"" >> allmocs.moc.cpp; \
 	done;
 
-MOSTLYCLEANFILES = ${QTUIMOC_TARGETS}
-	
 #EXTRA_DIST = ${molecuilder_DATA}
 
@@ -314,5 +396,21 @@
 
 $(srcdir)/version.c: $(srcdir)/.git-version
-	echo "const char *ESPACKVersion = \"$(PACKAGE_NAME) -- git version: "`cat $(srcdir)/.git-version`"\";" > $@
-
-
+	echo "const char *MOLECUILDERVERSION = \"$(PACKAGE_NAME) version "`cat $(srcdir)/.git-version`"\";" > $@
+
+
+unity.cpp: ${MOLECUILDERSOURCE} ${MOLECUILDERHEADER}
+	echo "#include \"$(srcdir)/Helpers/MemDebug.cpp\"" >  unity.cpp; \
+	list='$(MOLECUILDERSOURCE)'; for file in $$list; do \
+  	echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done; \
+	subdirs='$(SUBDIRS)';for directory in $$subdirs; do\
+		olddir=$$PWD;\
+		cd $$directory && make unity.cpp;\
+		cd $$olddir;\
+		echo "#include \"$$directory/unity.cpp\"" >> unity.cpp;\
+	done;\
+	echo "#include \"$(srcdir)/builder.cpp\"" >> unity.cpp;
+	echo "#include \"$(srcdir)/version.c\"" >> unity.cpp;
+
+MOSTLYCLEANFILES = allmocs.moc.cpp unity.cpp 
+	
Index: src/Parser/ChangeTracker.cpp
===================================================================
--- src/Parser/ChangeTracker.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/ChangeTracker.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ChangeTracker.cpp
@@ -6,8 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
+
 #include "Parser/ChangeTracker.hpp"
 #include "Patterns/Singleton_impl.hpp"
-
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 /**
@@ -15,7 +29,7 @@
  */
 ChangeTracker::ChangeTracker() :
-  Observable("ChangeTracker")
+  Observable("ChangeTracker"),
+  isConsistent(true)
 {
-  isConsistent = true;
   World::getInstance().signOn(this);
 }
@@ -49,4 +63,5 @@
  */
 void ChangeTracker::saveStatus() {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes." << std::endl);
   if (hasChanged()) {
     notifyAll();
Index: src/Parser/FormatParser.cpp
===================================================================
--- src/Parser/FormatParser.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/FormatParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * FormatParser.cpp
@@ -5,4 +12,9 @@
  *      Author: metzler
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -17,8 +29,8 @@
  */
 FormatParser::FormatParser() :
-  Observer("FormatParser")
+  Observer("FormatParser"),
+  saveStream(NULL)
 {
   ChangeTracker::getInstance().signOn(this);
-  saveStream = NULL;
 }
 
Index: src/Parser/FormatParserStorage.cpp
===================================================================
--- src/Parser/FormatParserStorage.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/FormatParserStorage.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /** \file FormatParserStorage.cpp
  *
@@ -6,4 +13,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include <iostream>
 #include <fstream>
@@ -14,9 +28,10 @@
 #include "Parser/MpqcParser.hpp"
 #include "Parser/PcpParser.hpp"
+#include "Parser/PdbParser.hpp"
 #include "Parser/TremoloParser.hpp"
 #include "Parser/XyzParser.hpp"
 
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 #include "Helpers/Assert.hpp"
@@ -42,8 +57,24 @@
   ParserSuffix.resize(ParserTypes_end, "");
 
+  ParserNames[mpqc] = "mpqc";
+  ParserNames[pcp] = "pcp";
+  ParserNames[pdb] = "pdb";
+  ParserNames[tremolo] = "tremolo";
+  ParserNames[xyz] = "xyz";
+
+  for (std::map<ParserTypes, std::string>::const_iterator it = ParserNames.begin(); it != ParserNames.end(); ++it)
+    ParserLookupNames.insert(pair<std::string, ParserTypes>(it->second,it->first) );
+
   ParserSuffix[mpqc] = "in";
   ParserSuffix[pcp] = "conf";
+  ParserSuffix[pdb] = "pdb";
   ParserSuffix[tremolo] = "data";
   ParserSuffix[xyz] = "xyz";
+
+  ParserAddFunction[mpqc] = &FormatParserStorage::addMpqc;
+  ParserAddFunction[pcp] = &FormatParserStorage::addPcp;
+  ParserAddFunction[pdb] = &FormatParserStorage::addPdb;
+  ParserAddFunction[tremolo] = &FormatParserStorage::addTremolo;
+  ParserAddFunction[xyz] = &FormatParserStorage::addXyz;
 }
 
@@ -98,4 +129,5 @@
 }
 
+
 /** Adds an PcpParser to the storage.
  */
@@ -110,4 +142,16 @@
 
 
+/** Adds an PdbParser to the storage.
+ */
+void FormatParserStorage::addPdb()
+{
+  if (!ParserPresent[pdb]) {
+    ParserList[pdb] = new PdbParser();
+    ParserPresent[pdb] = true;
+  } else
+    DoeLog(1) && (eLog() << Verbose(1) << "Parser pdb is already present." << endl);
+}
+
+
 /** Adds an TremoloParser to the storage.
  */
@@ -132,4 +176,35 @@
     DoeLog(1) && (eLog() << Verbose(1) << "Parser xyz is already present." << endl);
 }
+
+ParserTypes FormatParserStorage::getType(std::string type)
+{
+  if (ParserLookupNames.find(type) == ParserLookupNames.end()) {
+    DoeLog(1) && (eLog() << Verbose(1) << "Unknown type " << type << "." << endl);
+    return ParserTypes_end;
+  } else
+    return ParserLookupNames[type];
+}
+
+bool FormatParserStorage::add(ParserTypes ptype)
+{
+  if (ptype != ParserTypes_end) {
+    if (ParserAddFunction.find(ptype) != ParserAddFunction.end()) {
+      DoLog(0) && (Log() << Verbose(0) << "Adding " << ParserNames[ptype] << " type to output." << endl);
+      (getInstance().*(ParserAddFunction[ptype]))(); // we still need an object to work on ...
+      return true;
+    } else {
+      DoeLog(1) && (eLog() << Verbose(1) << "No parser to add for this known type " << ParserNames[ptype] << ", not implemented?" << endl);
+      return false;
+    }
+  } else {
+    return false;
+  }
+}
+
+bool FormatParserStorage::add(std::string type)
+{
+  return add(getType(type));
+}
+
 
 /** Parses an istream depending on its suffix
@@ -144,4 +219,6 @@
   } else if (suffix == ParserSuffix[pcp]) {
     getPcp().load(&input);
+  } else if (suffix == ParserSuffix[pdb]) {
+    getPdb().load(&input);
   } else if (suffix == ParserSuffix[tremolo]) {
     getTremolo().load(&input);
@@ -149,5 +226,5 @@
     getXyz().load(&input);
   } else {
-    DoeLog(1) && (eLog() << Verbose(1) << "Unknown suffix to for FormatParserStorage::get()." << endl);
+    DoeLog(1) && (eLog() << Verbose(1) << "Unknown suffix " << suffix << " to for FormatParserStorage::get()." << endl);
     return false;
   }
@@ -175,4 +252,14 @@
 }
 
+/** Returns reference to the output PdbParser, adds if not present.
+ * \return reference to the output PdbParser
+ */
+PdbParser &FormatParserStorage::getPdb()
+{
+  if (!ParserPresent[pdb])
+    addPdb();
+  return dynamic_cast<PdbParser &>(*ParserList[pdb]);
+}
+
 /** Returns reference to the output TremoloParser, adds if not present.
  * \return reference to the output TremoloParser
Index: src/Parser/FormatParserStorage.hpp
===================================================================
--- src/Parser/FormatParserStorage.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/FormatParserStorage.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -17,8 +17,10 @@
 
 #include <string>
+#include <map>
 #include <vector>
 
 class FormatParser;
 class MpqcParser;
+class PdbParser;
 class PcpParser;
 class TremoloParser;
@@ -26,5 +28,5 @@
 
 // enum has to be outside of class for operator++ to be possible
-enum ParserTypes { mpqc, pcp, tremolo, xyz, ParserTypes_end, ParserTypes_begin = mpqc };
+enum ParserTypes { mpqc, pcp, pdb, tremolo, xyz, ParserTypes_end, ParserTypes_begin = mpqc };
 typedef enum ParserTypes ParserTypes;
 
@@ -35,15 +37,20 @@
 public:
 
-
   void addMpqc();
   void addPcp();
+  void addPdb();
   void addTremolo();
   void addXyz();
+  bool add(std::string type);
+  bool add(ParserTypes type);
 
   bool get(std::istream &input, std::string suffix);
   MpqcParser &getMpqc();
   PcpParser &getPcp();
+  PdbParser &getPdb();
   TremoloParser &getTremolo();
   XyzParser &getXyz();
+
+  ParserTypes getType(std::string type);
 
   void SetOutputPrefixForAll(std::string &_prefix);
@@ -67,4 +74,12 @@
   std::vector<std::string> ParserSuffix;
 
+  // function pointers to each add...()
+  std::map< ParserTypes, void (FormatParserStorage::*)() > ParserAddFunction;
+
+  // type name of each parser type and reverse lookup
+  std::map<ParserTypes, std::string> ParserNames;
+  std::map<std::string, ParserTypes> ParserLookupNames;
+
+
   // prefix of the filenames to use on save
   std::string prefix;
Index: src/Parser/Makefile.am
===================================================================
--- src/Parser/Makefile.am	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -13,4 +13,5 @@
   MpqcParser.cpp \
   PcpParser.cpp \
+  PdbParser.cpp \
   TremoloParser.cpp \
   XyzParser.cpp
@@ -22,4 +23,5 @@
   MpqcParser.hpp \
   PcpParser.hpp \
+  PdbParser.hpp \
   TremoloParser.hpp \
   XyzParser.hpp
@@ -66,2 +68,9 @@
 pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
 
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(PARSERSOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/Parser/MpqcParser.cpp
===================================================================
--- src/Parser/MpqcParser.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Parser/MpqcParser.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MpqcParser.cpp
@@ -6,4 +13,11 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include "MpqcParser.hpp"
 
@@ -11,8 +25,8 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
 #include "World.hpp"
 
@@ -22,14 +36,11 @@
  */
 MpqcParser::MpqcParser() : HessianPresent(false)
-{
-
-}
+{}
 
 /** Destructor of MpqcParser.
  *
  */
-MpqcParser::~MpqcParser() {
-
-}
+MpqcParser::~MpqcParser()
+{}
 
 /** Load an MPQC config file into the World.
@@ -43,4 +54,6 @@
 void MpqcParser::save(ostream *file)
 {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to MPQC ." << std::endl);
+
   if (HessianPresent)
     saveHessian(file);
@@ -54,5 +67,4 @@
 void MpqcParser::saveSimple(ostream *file)
 {
-  int AtomNo = 0;
   Vector center;
   vector<atom *> allatoms = World::getInstance().getAllAtoms();
@@ -60,5 +72,5 @@
   // calculate center
   for (vector<atom *>::iterator runner = allatoms.begin();runner != allatoms.end(); ++runner)
-    center += (*runner)->x;
+    center += (*runner)->getPosition();
   center.Scale(1./allatoms.size());
 
@@ -86,5 +98,5 @@
     // output of atoms
     for (vector<atom *>::iterator AtomRunner = allatoms.begin(); AtomRunner != allatoms.end(); ++AtomRunner) {
-      (*AtomRunner)->OutputMPQCLine(file, &center, &AtomNo);
+      (*AtomRunner)->OutputMPQCLine(file, &center);
     }
     *file << "\t}" << endl;
@@ -102,5 +114,4 @@
 void MpqcParser::saveHessian(ostream *file)
 {
-  int AtomNo = 0;
   Vector center;
   vector<atom *> allatoms = World::getInstance().getAllAtoms();
@@ -108,5 +119,5 @@
   // calculate center
   for (vector<atom *>::iterator runner = allatoms.begin();runner != allatoms.end(); ++runner)
-    center += (*runner)->x;
+    center += (*runner)->getPosition();
   center.Scale(1./allatoms.size());
 
@@ -133,5 +144,5 @@
     // output of atoms
     for (vector<atom *>::iterator AtomRunner = allatoms.begin(); AtomRunner != allatoms.end(); ++AtomRunner) {
-      (*AtomRunner)->OutputMPQCLine(file, &center, &AtomNo);
+      (*AtomRunner)->OutputMPQCLine(file, &center);
     }
     *file << "\t}" << endl;
